
    # 
    # #To avoid what we suppose wrong observations, we will subtitute the values higher than limit microg/m3
    # w <- length(which(df_obs$pollutant>limit))
    # if(w>=1){
    #   df_obs[df_obs$pollutant>limit,"pollutant"] <- limit
    #   print(paste0("The observations has been modified to exceed ", limit, " límit value. The number of observations modified are : ", w, " in the hour:", hour))
    # }

############################################################
#                                                          #
#                 Loop LOOCV                               #
#                                                          #
############################################################
print("Loop LOOCV")
#LOOCV_total and llista_uk_total is created empty to fill it later with LOOCV and raw model data respectivelly
LOOCV_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
colnames(LOOCV_total) <- local_stations@data$code #we want a matrix with empty data and the name of stations

#starting OK and LOOCV:
for (hour in 1:length_loop) {
  print(paste0("loop LOOCV number:",hour))
  
  #extract observations hourly
  
  if(time_resolution=="hourly"){
    df_obs_hour <- df_obs_sub[hour,-1] 
  }else{
    df_obs_hour <- df_obs_sub[, !names(df_obs_sub) %in% different_names]
    df_obs_hour <- df_obs_hour[hour,]
  }
  
  # #LOOCV don't work if there is any NA, so first we will remove negative obs and then substitute NA from model value (it will improve using other methods of gap filling)
  # if(isTRUE(anyNA(df_obs_hour)) | isTRUE(any(df_obs_hour<0))){
  #   
  #   df_obs_hour[sapply(df_obs_hour, is.numeric)] <- lapply(df_obs_hour[sapply(df_obs_hour,is.numeric)],function(x) replace(x, x<0,NA))
  #   
  #   # Seleccionar solo las filas con datos completos
  #   #!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  #   df_obs_hour                                  <- na.omit(df_obs_hour) #aqui tinc el problemita, m'elimina tot
  #   
  #   #df_obs_hour[df_obs_hour<0] <- ifelse(df_obs_hour<0, NA, df_obs_hour[df_obs_hour<0]) # substitutes negative values to NA
  #   #df_obs_hour <-  coalesce(df_obs_hour, llista_uk_total[hour,]) # Also, it can be done as: df_obs_hour[is.na(df_obs_hour)] <- llista_uk_total[n,][is.na(df_obs_hour)]
  #   
  #   print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
  # }
  
  

  #Jan: hem de mirar qui es guarda i es carrega quan no s'executa l'OK: llista_uk_total o llista_uk_total_df?
  llista_uk_total <- llista_uk_total_df
  #Jan: llista_uk_total ja és un data.frame, no?
  ok_hour <- llista_uk_total[hour,!(names(llista_uk_total) =="dates")]
  
  
  df_loocv                     <- data.frame(lat=local_stations@coords[,2],
                                             lon=local_stations@coords[,1],
                                             pollutant_model=as.numeric(ok_hour[1,]),
                                             code=local_stations@data$code)
  
  df_obs_loocv <- data.frame(pollutant_obs = as.numeric(df_obs_hour[1,]) , code = colnames(df_obs_hour))

  llista_loocv <- merge(df_loocv, df_obs_loocv, by = "code")
  
  llista_loocv <- na.omit(llista_loocv) #aqui tinc el problemita, m'elimina tot
  
  # Jan: dona problema local_stations i  df_obs_hour no tenen mateixes dims. A dalt una possibilitat per arreglar-ho.
  # Jan: Això no passava també abans?
  
  # #We will generate a data frame with obs and raw-model interpolated in the local stations
  # llista_loocv                     <- data.frame(lat=local_stations@coords[,2],
  #                                                lon=local_stations@coords[,1],
  #                                                pollutant_obs=as.numeric(df_obs_hour[1,]),
  #                                                pollutant_model=as.numeric(ok_hour[1,]),
  #                                                code=colnames(df_obs_hour))
  

  coordinates(llista_loocv)        <- ~lon+lat
  sp::proj4string(llista_loocv)    <- crs_model
  
  #config the coordinates in UTM
  if (compute_in_UTM) {
    # Jan: not working! sp::proj4string(llista_loocv) <- crs_model_utm
    llista_loocv <- spTransform(llista_loocv, sp::CRS(crs_model_utm))
  } else {
    sp::proj4string(llista_loocv) <- crs_model
  }
  
  # Compute LOOCV variogram
  
  pollutant.fit_loocv <- automap::autofitVariogram(formula=pollutant_obs~pollutant_model,input_data=llista_loocv, verbose=FALSE)
  
  #Emergency Variogram if range of the current Variogram it's negative
  if(any(pollutant.fit_loocv$var_model$range<0)){
    print('UK Variogram had negative range')
    pollutant.fit_loocv=readRDS(variogram_uk)
  }
  
  #coef(lm(pollutant_obs ~  pollutant_model , llista_uk))['pollutant_model'] is the same as slope:
  slope <- summary(lm(pollutant_obs ~  pollutant_model , llista_loocv))$coefficients[,1][-1] 
  #p     <-summary(lm(pollutant_obs ~  pollutant_model , llista_uk))$coefficients[,4][-1] #p value.
  
  # if the slope is negative, we substitute all points for that hour by the model
  # Duda existencial tonta: si bé volem corretgir el model perquè no ho substituim per les observacions que són més correctes? R: potser de cara a avaluar el model es lo més correcte...
  # Estàs pensant en la LOOCV, l'objectiu final és corregir un mapa: no tenim observacions a tots els punts del mapa. Si amb les observacions no podem definir un model linear minimament coherent... casi millor no corregir i dexar el mapa amb el model raw
  # Jan: if(base::isTRUE(slope[1] < 0)){
  if(slope[1] < 0){
    
    #ok_loocv              <- NULL
    ok_loocv              <- as.data.frame(llista_loocv$pollutant_model)
    colnames(ok_loocv)    <- c("var1.pred")
    coordinates(ok_loocv) <- llista_loocv@coords
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      sp::proj4string(ok_loocv) <- crs_model_utm
    } else {
      sp::proj4string(ok_loocv) <- crs_model
    }
    
    print(paste0("The slope in hour ", hour, " is ", slope, ". We did not apply LOOCV, raw-model value is picked for this hour"))
    
  }else {
    # LOOCV
    ok_loocv             <- krige.cv(pollutant_obs~pollutant_model,llista_loocv,pollutant.fit_loocv$var_model)
    
  }
  # Save LOOCV and raw_model
  uk_loocv_h           <- matrix(data=ok_loocv@data$var1.pred, nrow=1)
  colnames(uk_loocv_h) <- llista_loocv@data$code
  
  LOOCV_total          <-  plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
  
}


LOOCV_total_df       <- as.data.frame(LOOCV_total)
LOOCV_total_df$dates <- date_times$date


#Arrange LOOCV_total_df to remove negative values:
LOOCV_total_df_wd        <- LOOCV_total_df %>% dplyr::select(-dates)

# Realment es podria fer abans de juntar el date al sortir del bucle. Ho deixo així perquè tenim LOOCV guardat amb la data
dates                    <- LOOCV_total_df %>% dplyr::select(dates) 

for(i in 1:nrow(local_stations)){
  LOOCV_total_df_wd[[i]] <- replace(LOOCV_total_df[[i]], LOOCV_total_df[[i]]<0, 0)
}

LOOCV_total_df <- cbind(LOOCV_total_df_wd,dates)

#Verification of negative values 'which(llista_uk_total_df<0)'. At the moment we don't apply it to llista_uk_total because it doesn't have negative values

if (save_LOOCV){
  saveRDS(object=LOOCV_total, file=paste0(save_result,"LOOCV_",pollutant,".rds"))
  saveRDS(object=LOOCV_total_df, file=paste0(save_result,"LOOCV_",pollutant,"_df.rds"))  
  print("LOOCV saved")
} else {
  print("LOOCV have not been saved")
}

